@echo off

:Main

SET VENDOR_HBA_FOUND=false
SET EMULEX_HBA_ADAPTERN=0
SET QLOGIC_HBA_ADAPTERN=0
SET HBA_VENDOR_OUI=Unset
SET HBA_VENDOR=Unset
SET IEEE_STANDARD=Unset
SET RC=0

REM /*--- If utility is not found within the Sep, these variables must be empty. ---*/
IF /I "%TK_SCLI_DIR_PATH%" == "" IF /I "%TK_SCLI_UTILITY%" == "" (

	REM /*--- Use the default path to the bin directory supplied by the Toolkit. ---*/
	Set TK_SCLI_DIR_PATH=%TK_Path_Bin%
	Set TK_SCLI_UTILITY=scli.exe
)

Lecho "\n%%t [ %0 ] - Using QLogic utility '%TK_SCLI_UTILITY%' found inside directory '%TK_SCLI_DIR_PATH%'\n" /F

REM /*--- If utility is not found within the Sep, these variables must be empty. ---*/
IF /I "%TK_WINLPCFG_DIR_PATH%" == "" IF /I "%TK_WINLPCFG_UTILITY%" == "" (

	REM /*--- Use the default path to the bin directory supplied by the Toolkit. ---*/
	Set TK_WINLPCFG_DIR_PATH=%TK_Path_Bin%
	Set TK_WINLPCFG_UTILITY=winlpcfg.exe
)

Lecho "\n%%t [ %0 ] - Using Emulex utility '%TK_WINLPCFG_UTILITY%' found inside directory '%TK_WINLPCFG_DIR_PATH%'\n" /F

REM /*--- If HBA_ID has WWPN number. ---*/
IF /I "%HBA_ID:~2,1%" == "-" (

	REM /*--- Let's check for 1 - IEEE 803.2 standard 48-bit ID. ---*/
	IF /I "%HBA_ID:~0,5%" == "10-00" (

		SET IEEE_STANDARD=1
		SET HBA_VENDOR_OUI=%HBA_ID:~6,8%
	)

	REM /*--- Let's check for 2 - IEEE 803.2 extended 48-bit ID. ---*/
	IF /I "%HBA_ID:~0,1%" == "2" (

		SET IEEE_STANDARD=2
		SET HBA_VENDOR_OUI=%HBA_ID:~6,8%
	)

	REM /*--- Let's check for 5 - IEEE Registered Name. ---*/
	IF /I "%HBA_ID:~0,1%" == "5" (

		SET IEEE_STANDARD=5
		SET HBA_VENDOR_OUI=%HBA_ID:~1,9%
	)

) ELSE (

	IF /I NOT "%HBA_ID:~2,1%" == "" (

		REM /*--- Let's check for 1 - IEEE 803.2 standard 48-bit ID. ---*/
		IF /I "%HBA_ID:~0,4%" == "1000" (

			SET IEEE_STANDARD=1
			SET HBA_VENDOR_OUI=%HBA_ID:~4,6%
		)

		REM /*--- Let's check for 2 - IEEE 803.2 extended 48-bit ID. ---*/
		IF /I "%HBA_ID:~0,1%" == "2" (

			SET IEEE_STANDARD=2
			SET HBA_VENDOR_OUI=%HBA_ID:~4,6%
		)

		REM /*--- Let's check for 5 - IEEE Registered Name. ---*/
		IF /I "%HBA_ID:~0,1%" == "5" (

			SET IEEE_STANDARD=5
			SET HBA_VENDOR_OUI=%HBA_ID:~1,6%
		)
	)
)

REM /*--- Let's check for 1 - IEEE 803.2 standard 48-bit ID. ---*/
IF /I "%IEEE_STANDARD%" == "1" (

	REM /*--- Check for QLogic OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-14-05" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-1B-32" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-24-FF" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-C0-DD" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-E0-8B" SET HBA_VENDOR=qlogic

	IF /I "%HBA_VENDOR_OUI%" == "001405" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001B32" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0024FF" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00C0DD" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00E08B" SET HBA_VENDOR=qlogic

	REM /*--- Check for IBM OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-02-55" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-04-AC" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-06-29" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-09-6B" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-0D-60" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-10-D9" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-11-25" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-14-5E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-1A-64" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-20-35" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-21-5E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-50-76" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-60-94" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "08-00-5A" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10-00-00" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10-00-5A" SET HBA_VENDOR=qlogic

	IF /I "%HBA_VENDOR_OUI%" == "000255" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0004AC" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "000629" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00096B" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "000D60" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0010D9" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001125" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00145E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001A64" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "002035" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00215E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "005076" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "006094" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "08005A" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "100000" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10005A" SET HBA_VENDOR=qlogic

	REM /*--- Check for Emulex OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-00-C9" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-0A-33" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-0E-03" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-10-9B" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-90-FA" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-E0-D5" SET HBA_VENDOR=emulex

	IF /I "%HBA_VENDOR_OUI%" == "0000C9" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "000A33" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "000E03" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00109B" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0090FA" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00E0D5" SET HBA_VENDOR=emulex

	REM /*--- Check for Brocade OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-00-88" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-01-0F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-05-1E" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-05-33" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-14-C9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-60-69" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-60-DF" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "08-00-88" SET HBA_VENDOR=brocade

	IF /I "%HBA_VENDOR_OUI%" == "000088" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00010F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00051E" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "000533" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0014C9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "006069" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0060DF" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "080088" SET HBA_VENDOR=brocade
)

REM /*--- Let's check for 2 - IEEE 803.2 extended 48-bit ID. ---*/
IF /I "%IEEE_STANDARD%" == "2" (

	REM /*--- Check for QLogic OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-14-05" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-1B-32" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-24-FF" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-C0-DD" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-E0-8B" SET HBA_VENDOR=qlogic

	IF /I "%HBA_VENDOR_OUI%" == "001405" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001B32" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0024FF" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00C0DD" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00E08B" SET HBA_VENDOR=qlogic

	REM /*--- Check for IBM OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-02-55" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-04-AC" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-06-29" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-09-6B" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-0D-60" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-10-D9" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-11-25" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-14-5E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-1A-64" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-20-35" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-21-5E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-50-76" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-60-94" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "08-00-5A" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10-00-00" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10-00-5A" SET HBA_VENDOR=qlogic

	IF /I "%HBA_VENDOR_OUI%" == "000255" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0004AC" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "000629" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00096B" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "000D60" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0010D9" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001125" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00145E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001A64" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "002035" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00215E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "005076" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "006094" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "08005A" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "100000" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10005A" SET HBA_VENDOR=qlogic

	REM /*--- Check for Emulex OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-00-C9" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-0A-33" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-0E-03" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-10-9B" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-90-FA" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00-E0-D5" SET HBA_VENDOR=emulex

	IF /I "%HBA_VENDOR_OUI%" == "0000C9" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "000A33" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "000E03" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00109B" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0090FA" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00E0D5" SET HBA_VENDOR=emulex

	REM /*--- Check for Brocade OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-00-88" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-01-0F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-05-1E" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-05-33" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-14-C9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-60-69" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00-60-DF" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "08-00-88" SET HBA_VENDOR=brocade

	IF /I "%HBA_VENDOR_OUI%" == "000088" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00010F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00051E" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "000533" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0014C9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "006069" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0060DF" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "080088" SET HBA_VENDOR=brocade
)

REM /*--- Let's check for 5 - IEEE Registered Name. ---*/
IF /I "%IEEE_STANDARD%" == "5" (

	REM /*--- Check for QLogic OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "0-01-40-5" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0-01-B3-2" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0-02-4F-F" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0-0C-0D-D" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0-0E-08-B" SET HBA_VENDOR=qlogic

	IF /I "%HBA_VENDOR_OUI%" == "001405" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001B32" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0024FF" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00C0DD" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00E08B" SET HBA_VENDOR=qlogic

	REM /*--- Check for IBM OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "00-02-55" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-04-AC" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-06-29" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-09-6B" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-0D-60" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-10-D9" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-11-25" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-14-5E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-1A-64" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-20-35" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-21-5E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-50-76" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00-60-94" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "08-00-5A" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10-00-00" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10-00-5A" SET HBA_VENDOR=qlogic

	IF /I "%HBA_VENDOR_OUI%" == "000255" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0004AC" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "000629" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00096B" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "000D60" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "0010D9" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001125" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00145E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "001A64" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "002035" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "00215E" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "005076" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "006094" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "08005A" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "100000" SET HBA_VENDOR=qlogic
	IF /I "%HBA_VENDOR_OUI%" == "10005A" SET HBA_VENDOR=qlogic

	REM /*--- Check for Emulex OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "0-00-0C-9" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0-00-A3-3" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0-00-E0-3" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0-01-09-B" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0-09-0F-A" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0-0E-0D-5" SET HBA_VENDOR=emulex

	IF /I "%HBA_VENDOR_OUI%" == "0000C9" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "000A33" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "000E03" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00109B" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "0090FA" SET HBA_VENDOR=emulex
	IF /I "%HBA_VENDOR_OUI%" == "00E0D5" SET HBA_VENDOR=emulex

	REM /*--- Check for Brocade OUI IDs. ---*/
	IF /I "%HBA_VENDOR_OUI%" == "0-00-08-8" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-00-10-F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-00-51-E" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-00-53-3" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-01-4C-9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-06-06-9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-06-0D-F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0-80-08-8" SET HBA_VENDOR=brocade

	IF /I "%HBA_VENDOR_OUI%" == "000088" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00010F" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "00051E" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "000533" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0014C9" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "006069" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "0060DF" SET HBA_VENDOR=brocade
	IF /I "%HBA_VENDOR_OUI%" == "080088" SET HBA_VENDOR=brocade
)

REM /* If we were not able to detect the HBA_VENDOR, let's ask each utility
REM  * to locate the owner of this HBA.
REM */
IF /I "%HBA_VENDOR%" == "Unset" SET HBA_VENDOR=qlogic

REM /*--- Let's try to find out if this WWPN is present. ---*/
IF /I "%HBA_VENDOR%" == "qlogic" (

	pushd "%TK_SCLI_DIR_PATH%"

	%TK_SCLI_UTILITY% -e %HBA_ID% VIEW
	IF errorlevel 1 (

		REM /*--- The Vendor HBA was not found. ---*/
		SET VENDOR_HBA_FOUND=false
	) ELSE (

		REM /*--- Let's set the Adapter Number (Instance or WWPN). ---*/
		SET QLOGIC_HBA_ADAPTERN=%HBA_ID%

		REM /*--- Let's set the flag to true. ---*/
		SET VENDOR_HBA_FOUND=true
	)

	REM /*--- If we didn't find the qlogic, then let's try emulex. ---*/
	IF /I "!VENDOR_HBA_FOUND!" == "false" (

		REM /*--- Set flag to check for emulex. ---*/
		SET HBA_VENDOR=emulex
	)

	popd
)

REM /* Let's find out if this WWPN is present.  For emulex we need to
REM  * do something special because it only configures its HBAs by
REM  * adapter number, so we need to translate the WWPN to adapater
REM  * number.  For Qlogic, we don't need to do because it accepts
REM  * the WWPN with/without dashes.
REM  *
REM */
IF /I "%HBA_VENDOR%" == "emulex" (

	pushd "%TK_WINLPCFG_DIR_PATH%"

	SET HBA_ID_TEMP=%HBA_ID%

	REM /*--- If there are any dashes, remove them. ---*/
	IF /I "%HBA_ID:~2,1%" == "-" (

		FOR /F "tokens=2,3,4,5,6,7,8,9 delims=-=" %%A IN ('SET HBA_ID') DO (

			SET HBA_ID_TEMP=%%A%%B%%C%%D%%E%%F%%G%%H
		)
	)

	REM /* Let's execute the emulex to display the list hbas
	REM  * and extract the Adapter number from it.  This will tell us
	REM  * if exists.
	REM */
	FOR /F "tokens=1,2,3,4 delims=: " %%A IN ('%TK_WINLPCFG_UTILITY% listhba') DO (

		IF /I "%%A" == "adapter" (

			IF /I "!HBA_ID_TEMP!" == "%%C%%D" (

				SET EMULEX_HBA_ADAPTERN=%%B
				SET VENDOR_HBA_FOUND=true
			)		
		)
	)

	REM /*--- If we still didn't find the vendor, let's try the last option. ---*/
	IF /I "!VENDOR_HBA_FOUND!" == "false" (

		REM /*--- Set the vendor to Unset. ---*/
		SET HBA_VENDOR=Unset
	)

	popd
)

REM /* If we didn't detect the HBA by the WWPN is because the
REM  * user may have used the <hba instance> instead.  For this case
REM  * we need to scan the adapter through PCI scanning.
REM */
IF /I "%HBA_VENDOR%" == "Unset" (

	REM /*--- Set HBA Vendor to unknown. ---*/
	SET HBA_VENDOR=unknown

	REM /*--- Let's store and increment the HBA ID. ---*/
	SET /A HBA_ID_TEMP=%HBA_ID%
	SET /A HBA_ID_TEMP+=1

	REM /*--- Keeps track of the total number of supported adapters found. ---*/
	SET /A SUPPORTED_ADAPTERS=0

	REM /*--- QLogic instance starts at 0. ---*/
	SET QLOGIC_HBA_ADAPTERN=0

	REM /*--- Emulex instance starts at 1. ---*/
	SET EMULEX_HBA_ADAPTERN=1

	REM /*--- This flag is set to true when the adapter (HBA_ID) is found. ---*/
	FOR /F "tokens=1,2,3,4,5 delims=.:= " %%A IN ('hwdetect.exe /i') DO (

		IF /I "!VENDOR_HBA_FOUND!" == "false" (

			REM /*--- If we find a QLogic ID. ---*/
			IF /I "Vendor_ID" == "%%A" IF /I "0x1077" == "0x%%C" (

				pushd "%TK_SCLI_DIR_PATH%"

				REM /*--- Let's increment the total number of supported adapter number found. ---*/
				SET /A SUPPORTED_ADAPTERS+=1

				REM /*--- Let's run the QLogic utility to try to find out if scli supports this adapter. ---*/
				%TK_SCLI_UTILITY% -e !QLOGIC_HBA_ADAPTERN! VIEW
				IF errorlevel 1 (

					REM /*--- This is not a supported adapter, let's decrement. ---*/
					SET /A SUPPORTED_ADAPTERS-=1

				) ELSE (

					IF /I "!SUPPORTED_ADAPTERS!" == "!HBA_ID_TEMP!" (

						REM /*--- Let's set the flag that we found the target adapter to true. ---*/
						SET VENDOR_HBA_FOUND=true

						REM /*--- Let's set the vendor name. ---*/
						SET HBA_VENDOR=qlogic
					
					) ELSE (

						REM /*--- Let's increment the qlogic instance. ---*/
						SET /A QLOGIC_HBA_ADAPTERN+=1
					)
				)

				popd
			)

			REM /*--- If we find the Emulex ID. ---*/
			IF /I "Vendor_ID" == "%%A" IF /I "0x10DF" == "0x%%C" (

				pushd "%TK_WINLPCFG_DIR_PATH%"

				REM /*--- Let's increment the total number of supported adapter number found. ---*/
				SET /A SUPPORTED_ADAPTERS+=1

				REM /*--- Let's run the Emulex utility to try to find out if winlpcfg supports this adapter. ---*/
				%TK_WINLPCFG_UTILITY% readbootdevice n=!EMULEX_HBA_ADAPTERN!
				IF errorlevel 1 (

					REM /*--- This is not a supported adapter, let's decrement. ---*/
					SET /A SUPPORTED_ADAPTERS-=1
				) ELSE (

					IF /I "!SUPPORTED_ADAPTERS!" == "!HBA_ID_TEMP!" (

						REM /*--- Let's set the flag that we found the target adapter to true. ---*/
						SET VENDOR_HBA_FOUND=true

						REM /*--- Let's set the vendor name. ---*/
						SET HBA_VENDOR=emulex

					) ELSE (

						REM /*--- Let's increment the emulex instance. ---*/
						SET /A EMULEX_HBA_ADAPTERN+=1
					)
				)

				popd
			)
		)
	)
)

REM /*--- If the HBA was successfully found. ---*/
IF /I "%VENDOR_HBA_FOUND%" == "true" (

	REM /*--- Let's set the return code to zero. ---*/
	SET RC=0
)
