@Echo off

rem ***************************************************************************
rem *                                                                         *
rem *  IBM (R) InstallSEPTK.cmd                                               *
rem *                                                                         *
rem *                                                                         *
rem *  Copyright 2008-2009.  All rights reserved.                             *
rem *                                                                         *
rem *  Called by:                                                             *
rem *  Calls:                                                                 * 
rem ***************************************************************************

SETLOCAL EnableDelayedExpansion

rem ***************************************************************************
rem *  Initialize
rem ***************************************************************************
:Initialize

set RC=0
set RMSG=

Lecho "TK_SEP_Temp_Path=%TK_SEP_Temp_Path%" /LO

Set TK_Path_SourceWinPEDrivers=%TK_SEP_Temp_Path%\sgdeploy\SGTKWinPE\Drivers
Set TK_Path_TargetWinPEDrivers=%TK_Path_SGDeploy%\SGTKWinPE\Drivers
Set TK_Path_SourceNOSDrivers=%TK_SEP_Temp_Path%\sgdeploy\drvs
Set TK_Path_TargetNOSDrivers=%TK_Path_SGDeploy%\drvs

:Initialize_End


rem ***************************************************************************
rem *  Display the banner.
rem ***************************************************************************
:DisplayBanner

Lecho "%%t " /F /SN /LO
Lecho "[%0] " /F /SN /LO
Lecho "- Copying Base Toolkit SEP files...\n" /F /LO

:DisplayBanner_End


rem ***************************************************************************
rem *  Cleanup any target WinPE driver directories before the copy
rem ***************************************************************************
:CleanupTargetWinPEDriverDirectories

for /f "tokens=* usebackq" %%A in (`DIR /B /A /N /O !TK_Path_SourceWinPEDrivers!`) DO (
    Set SourceDirectory=%%A

    if exist "!TK_Path_TargetWinPEDrivers!\!SourceDirectory!" (
        rmdir /S /Q "!TK_Path_TargetWinPEDrivers!\!SourceDirectory!" 
        Lecho "Successfully removed target directory !TK_Path_TargetWinPEDrivers!\!SourceDirectory!" /LO
    )
)

:CleanupTargetWinPEDriverDirectories_End


rem ***************************************************************************
rem *  Cleanup any target NOS driver directories before the copy
rem ***************************************************************************
:CleanupTargetNOSDriverDirectories

for /f "tokens=* usebackq" %%A in (`DIR /B /A /N /O !TK_Path_SourceNOSDrivers!`) DO (
    Set SourceDirectory=%%A

    if exist "!TK_Path_TargetNOSDrivers!\!SourceDirectory!" (
        rmdir /S /Q "!TK_Path_TargetNOSDrivers!\!SourceDirectory!" 
        Lecho "Successfully removed target directory !TK_Path_TargetNOSDrivers!\!SourceDirectory!" /LO
    )
)

:CleanupTargetNOSDriverDirectories_End


rem ***************************************************************************
rem *  Copy the WinPE Drivers from the SEP.
rem ***************************************************************************
:CopyWinPEDrivers

Lecho "Copying the WinPE Drivers from the SEP, source=%TK_Path_SourceWinPEDrivers%, target=%TK_Path_TargetWinPEDrivers%" /LO

Set Command=xcopy "%TK_Path_SourceWinPEDrivers%\*" "%TK_Path_TargetWinPEDrivers%" /S /Y /E /I

%Command% >> "%Lecho_Log%" 

if errorlevel 1 (
    Set RC=%errorlevel%
    Set RMSG=%Command% returned a non-zero error code!
    goto Error_LD
)

Lecho "errorlevel=%errorlevel%" /LO

:CopyWinPEDrivers_End


rem ***************************************************************************
rem *  Copy the NOS Drivers from the SEP.
rem ***************************************************************************
:CopyNOSDrivers

Lecho "Copying the NOS Drivers from the SEP, source=%TK_Path_SourceNOSDrivers%, target=%TK_Path_TargetNOSDrivers%" /LO
Set Command=xcopy "%TK_Path_SourceNOSDrivers%\*" "%TK_Path_TargetNOSDrivers%" /S /Y /E /I

%Command% >> "%Lecho_Log%" 

if errorlevel 1 (
    Set RC=%errorlevel%
    Set RMSG=%Command% returned a non-zero error code!
    goto Error_LD
)

Lecho "errorlevel=%errorlevel%" /LO

:CopyNOSDrivers_End


rem ***************************************************************************
rem *  Success
rem ***************************************************************************
:Success

Lecho "%%t " /F /SN /LO
Lecho "[%0] " /F /SN /LO
Lecho "- Copy Base Toolkit SEP files completed successfully.\n" /F /LO

Goto End

:Success_End


rem ***************************************************************************
rem *  Error Handler
rem ***************************************************************************
:Error

Call ErrorHandler %0

goto Error_End     
     
:Error_D

Call ErrorHandler %0 /Display

goto Error_End     

:Error_L

Call ErrorHandler %0 /Log

goto Error_End     

:Error_LD
               
Call ErrorHandler %0 /Log /Display

:Error_End


rem ***************************************************************************
rem *  End of script.
rem ***************************************************************************
:End

