@Echo off

rem ***************************************************************************
rem *                                                                         *
rem *                     IBM (R) InstallSep.cmd                              *
rem *                                                                         *
rem *  Copyright 2009.  All rights reserved.                                  *
rem *                                                                         *
rem *   Updated: 11/10/2009                                                   *
rem *                                                                         *
rem *   Called by:                                                            *
rem *    - WinPE Tookit: InitializeToolkit.cmd                                *
rem *    - Altiris Deployment: (N/A)                                          *
rem *                                                                         *
rem *   Parameters:                                                           *
rem *                                                                         *
rem *   Prerequisites:                                                        *
rem *    - InitializeToolkit.cmd script                                       *
rem *                                                                         *
rem ***************************************************************************


rem ***************************************************************************
rem *  Initialize
rem ***************************************************************************
:Initialize

set RC=0
set RMSG=

:Initialize_E


rem ***************************************************************************
rem *  Display the banner.
rem ***************************************************************************
:DisplayBanner

if /i "%TK_Flag_SuppressBanner%" == "Yes" (
    set TK_Flag_SuppressBanner=
    goto DisplayBanner_E
)    

:DisplayBanner_E


rem ***************************************************************************
rem *  Perform Service Enable Pack
rem ***************************************************************************
:InstallSep

if exist "%SystemDrive%\sgdeploy\SGTKWinPE\Drivers" rmdir /S /Q "%SystemDrive%\sgdeploy\SGTKWinPE\Drivers"
if not exist "%SystemDrive%\sgdeploy\SGTKWinPE\Bin" mkdir "%SystemDrive%\sgdeploy\SGTKWinPE\Bin"

Set Command=xcopy /E /S /I /Q "%SystemDrive%\sgdeploy\SGTKWinPE\Bin\win32\*" "%SystemDrive%\sgdeploy\SGTKWinPE\Bin" /y
if /i "%TK_Build_WinPE_Arch_Type%" == "x64" Set Command=xcopy /E /S /I /Q "%SystemDrive%\sgdeploy\SGTKWinPE\Bin\winx64\*" "%SystemDrive%\sgdeploy\SGTKWinPE\Bin" /y

%Command%

if errorlevel 1 (
    set RC=%errorlevel%
    set RMSG=%Command% returned a non-zero error code!
    goto Error_LD
)

rem 1) Let's find out if this is a WinPE x86.
if /i "%TK_Build_WinPE_Arch_Type%" == "x86" set Path=%SystemDrive%\sgdeploy\SGTKWinPE;%SystemDrive%\sgdeploy\SGTKWinPE\Bin;%SystemDrive%\sgdeploy\SGTKWinPE\Scripts;%Path%

rem 2) Let's find out if this is a WinPE x64.
if /i "%TK_Build_WinPE_Arch_Type%" == "x64" set Path=%SystemDrive%\sgdeploy\SGTKWinPE;%SystemDrive%\sgdeploy\SGTKWinPE\Bin;%SystemDrive%\sgdeploy\SGTKWinPE\Scripts;%Path%

rem 3) Check for hardcoded variables, and if found, update the path to point to the System Drive only for Network/Altiris deployments.
rem    Otherwise, leave them as they are.
if /i "%TK_Environment_ToolkitFilesLocation%" == "Network" (

    if exist "%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\TK_CheckDiskSize.vbs" set TK_Partition_CheckDiskSizeVBS=%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\TK_CheckDiskSize.vbs
    if exist "%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\TK_DiskOrder.vbs" set TK_Partition_DiskOrderVBS=%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\TK_DiskOrder.vbs
    if exist "%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\TK_DiskPart.txt" set TK_Partition_ScriptName=%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\TK_DiskPart.txt
    if exist "%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\GetNextAvailableDrive.cmd" set TK_UXSP_GetNextAvailableDrive=%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\GetNextAvailableDrive.cmd
    if exist "%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\PerformUXSPUpdates.cmd" set TK_UXSP_PerformScript=%SystemDrive%\sgdeploy\SGTKWinPE\Scripts\PerformUXSPUpdates.cmd
)

:InstallSep_E


rem ***************************************************************************
rem *  Success
rem ***************************************************************************
:Success

Goto End

:Success_E


rem ***************************************************************************
rem *  Error Handler
rem ***************************************************************************
:Error_LD
               
Call ErrorHandler %0 /Log /Display

:Error_E


rem ***************************************************************************
rem *  End of script.
rem ***************************************************************************
:End

