@echo off

REM * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *
REM *                                                                         *
REM *             IBM (R) PerformQLogicFibreConfiguration.cmd                 *
REM *                                                                         *
REM *  Description: Perform QLogic Fibre Configuration                        *
REM *                                                                         *
REM * Dependencies:                                                           *
REM *     - PerformFibreConfiguration.cmd                                     *
REM *     - scli.exe + package                                                *
REM *     - CheckFibrePrerequisites.cmd                                       *
REM *     -
REM *                                                                         *
REM *             Copyright 2009.  All rights reserved.                       *
REM *                                                                         *
REM * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *

REM * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *
REM *                             Initialize                                  *
REM * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ *
:Main

SET RC=0

REM /*--- Let's set the execution type. ---*/
SET DO=%1

REM /*--- If utility is not found within the Sep, these variables must be empty. ---*/
IF /I "%TK_SCLI_DIR_PATH%" == "" IF /I "%TK_SCLI_UTILITY%" == "" (

	REM /*--- Use the default path to the bin directory supplied by the Toolkit. ---*/
	Set TK_SCLI_DIR_PATH=%TK_Path_Bin%
	Set TK_SCLI_UTILITY=scli.exe
)

Lecho "\n%%t [ %0 ] - Using QLogic utility '%TK_SCLI_UTILITY%' found inside directory '%TK_SCLI_DIR_PATH%'\n" /F

pushd "%TK_SCLI_DIR_PATH%"

IF /I "%DO%" == "prim-default-config" (

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring the Operating System to boot from the first disk drive the BIOS finds that is also a LUN 0 as boot device.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWNN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWPN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_LUNID%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWNN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWPN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_LUNID%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "prim-config" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Clearing the selected 'Prim' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable prim\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable prim

	!Command!

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring 'Prim' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWNN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWPN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_LUNID% prim\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWNN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_WWPN% %ENABLE_BOOT_PRIM_DEVICE_TARGET_LUNID% prim

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt1-default-config" (

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring the Operating System to boot from the first disk drive the BIOS finds that is also a LUN 0 as boot device.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_LUNID%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_LUNID%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt1-config" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Clearing the selected 'Alt1' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable alt1\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable alt1

	!Command!

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring 'Alt1' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_LUNID% alt1\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT1_DEVICE_TARGET_LUNID% alt1

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt2-default-config" (

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring the Operating System to boot from the first disk drive the BIOS finds that is also a LUN 0 as boot device.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_LUNID%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_LUNID%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt2-config" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Clearing the selected 'Alt2' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable alt2\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable alt2

	!Command!

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring 'Alt2' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_LUNID% alt2\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT2_DEVICE_TARGET_LUNID% alt2

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt3-default-config" (

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring the Operating System to boot from the first disk drive the BIOS finds that is also a LUN 0 as boot device.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_LUNID%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_LUNID%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt3-config" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Clearing the selected 'Alt3' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable alt3\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable alt3

	!Command!

	REM /*--- Before we do anything for this HBA, let's display the information about LUNs attached to this HBA. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Displaying Information about this HBA %QLOGIC_HBA_ADAPTERN%.  Executing -> %TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -l %QLOGIC_HBA_ADAPTERN%

	!Command!

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Configuring 'Alt3' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_LUNID% alt3\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWNN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_WWPN% %ENABLE_BOOT_ALT3_DEVICE_TARGET_LUNID% alt3

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "prim-disable" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Disabling the selected 'Prim' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_PRIM_DEVICE%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_PRIM_DEVICE%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt1-disable" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Disabling the selected 'Alt1' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_ALT1_DEVICE%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_ALT1_DEVICE%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt2-disable" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Disabling the selected 'Alt2' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_ALT2_DEVICE%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_ALT2_DEVICE%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

IF /I "%DO%" == "alt3-disable" (

	REM /*--- Display what's being executed. ---*/
	SET Command=Lecho "\n%%t [ %0 ] - Disabling the selected 'Alt3' boot device settings.  Executing -> %TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_ALT3_DEVICE%\n" /F

	!Command!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% disable %DISABLE_BOOT_ALT3_DEVICE%

	REM /*--- Execute the command. ---*/
	!Command!

	REM /*--- Set return code. ---*/
	SET RC=!errorlevel!

	REM /*--- Set the command line to be executed. ---*/
	SET Command=%TK_SCLI_UTILITY% -e %QLOGIC_HBA_ADAPTERN% VIEW

	!Command!
)

popd
